package com.ssm.controller;


import javax.persistence.Column;
import javax.persistence.Id;

import com.github.pagehelper.PageInfo;
import com.ssm.manage.entity.RlPower;
import com.ssm.manage.dto.RlPowerDto;
import com.ssm.manage.response.GenericResponse;
import com.ssm.manage.response.PageResponse;
import com.ssm.manage.response.ResponseCode;
import com.ssm.manage.service.RlPowerService;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;

import java.io.Serializable;

import lombok.extern.slf4j.Slf4j;
import com.ssm.core.utils.SnowflakeUtil;

import java.util.Random;

/**
 * 权限(RlPower)表控制层
 *
 * @author makejava
 * @since 2023-12-13 15:34:04
 */
@RestController
@RequestMapping("/rlPower")
@Slf4j
@Api(tags = "权限")
public class RlPowerController {
    /**
     * 服务对象
     */
    @Autowired
    private RlPowerService rlPowerService;

/**
 * 通过主键查询单条数据
 *
 * @param id 主键
 * @return
 @GetMapping("{id}")
 @ApiOperation("通过主键查询单条数据")
 //@RequiresPermissions("system:rlPower:query")
 public ResultVo get(@PathVariable Serializable id) {
 return this.rlPowerService.queryById(id);
 }
 */


    /**
     * 分页查询权限
     *
     * @param dto
     * @return
     */
    @GetMapping
    @ApiOperation("分页查询权限")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页码", defaultValue = "1", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页数量", defaultValue = "10", required = true)
    })
//@RequiresPermissions("system:rlPower:query")
    public PageResponse<RlPower> listPage(RlPowerDto dto) {
        PageResponse<RlPower> pageResponse = new PageResponse<>();
        PageInfo<RlPower> pageInfo = new PageInfo<>();
        try {
            pageInfo = this.rlPowerService.selectPage(dto);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.selectPage", e);
            pageResponse.setCodeAndMsg(ResponseCode.FAILED);
            return pageResponse;
        }
        pageResponse.setPageInfo(pageInfo);
        pageResponse.setCodeAndMsg(ResponseCode.OK);
        return pageResponse;
    }

    /**
     * 新增权限
     *
     * @param rlPower
     * @return
     */
    @PostMapping
    @ApiOperation("新增权限")
//@RequiresPermissions("system:rlPower:add")
    public GenericResponse add(@RequestBody RlPowerDto rlPower) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            i = this.rlPowerService.add(rlPower);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 编辑权限
     *
     * @param rlPower
     * @return
     */
    @PutMapping
    @ApiOperation("编辑权限")
//@RequiresPermissions("system:rlPower:edit")
    public GenericResponse edit(@RequestBody RlPower rlPower) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            i = this.rlPowerService.updateByPrimaryKey(rlPower);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 根据主键删除权限
     *
     * @param id 主键
     * @return
     */
    @DeleteMapping("{id}")
    @ApiOperation("根据主键删除权限")
//@RequiresPermissions("system:rlPower:delete")
    public GenericResponse delete(@PathVariable Long id) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            RlPower rlPower = new RlPower();
            i = this.rlPowerService.delete(rlPower);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

}
